package collectionExamples;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class genericsmax {

	public static void main(String[] args) {
		ArrayList<String> s = new ArrayList<String>();
		Comparator<String> c = new Comparator<String>() {
			public int compare(String s1, String s2) {
				return s1.length() - s2.length();
			}
		};
		s.add("a");
		s.add("bbbbbb");
		s.add("ccc");
		String max = maximum(s, c);
		System.out.println("The longest string is : " + max);

		String gmax = genmax(s, c);
		System.out.println("The longest string is : " + gmax);
		
		Collections.sort(s, c);
		
		for (String a : s) {
			System.out.print(a+" ");
		}
		System.out.println("\n\nstring order:");
		Collections.sort(s);
		
		for (String a : s) {
			System.out.print(a+" ");
		}
}

	public static String maximum(ArrayList<String> a, Comparator<String> c) {
		String max = a.get(0);
		for (String toTest : a) {
			if (c.compare(toTest, max) > 0)
				max = toTest;
		}
		return max;
	}

	public static <T> T genmax(ArrayList<T> a, Comparator<T> c) {
		T max = a.get(0);
		for (T toTest : a) {
			if (c.compare(toTest, max) > 0)
				max = toTest;
		}
		return max;
	}

}
